# -*- coding: utf-8 -*-

import sys,re,os
import urllib,urllib2
import urlparse

import xbmc,xbmcgui,xbmcaddon
import xbmcplugin

sys.path.append(os.path.join(os.path.dirname(os.path.realpath(__file__)), os.pardir))
print os.path.join(os.path.dirname(os.path.realpath(__file__)), os.pardir)
import urlresolver


base_url        = sys.argv[0]
addon_handle    = int(sys.argv[1])
args            = urlparse.parse_qs(sys.argv[2][1:])
my_addon        = xbmcaddon.Addon()
addonName       = my_addon.getAddonInfo('name')

PATH            = my_addon.getAddonInfo('path')
DATAPATH        = xbmc.translatePath(my_addon.getAddonInfo('profile')).decode('utf-8')
RESOURCES       = PATH+'/resources/'

import resources.lib.filmyto as filmyto
filmyto.COOKIEFILE=os.path.join(DATAPATH,'filmyto.cookie')
FANART=''
# xbmcplugin.setContent(addon_handle, 'movies')

## COMMON Functions


def addLinkItem(name, url, mode, params={}, iconimage='DefaultFolder.png', infoLabels=False, isFolder=False, IsPlayable=True,fanart=FANART,itemcount=1):
    u = build_url({'mode': mode, 'foldername': name, 'ex_link' : url, 'params':params})
    
    liz = xbmcgui.ListItem(name)
    
    art_keys=['thumb','poster','banner','fanart','clearart','clearlogo','landscape','icon']
    art = dict(zip(art_keys,[iconimage for x in art_keys]))
    art['landscape'] = fanart if fanart else art['landscape'] 
    art['fanart'] = fanart if fanart else art['landscape'] 
    liz.setArt(art)
        
    if not infoLabels:
        infoLabels={"title": name}
    liz.setInfo(type="video", infoLabels=infoLabels)
    if IsPlayable:
        liz.setProperty('IsPlayable', 'true')

    contextMenuItems = []
    contextMenuItems.append(('Informacja', 'XBMC.Action(Info)'))
    liz.addContextMenuItems(contextMenuItems, replaceItems=False)        
    ok = xbmcplugin.addDirectoryItem(handle=addon_handle, url=u, listitem=liz, isFolder=isFolder,totalItems=itemcount)
    xbmcplugin.addSortMethod(addon_handle, sortMethod=xbmcplugin.SORT_METHOD_NONE, label2Mask = "%R, %Y, %P")
    return ok

def addDir(name,ex_link=None, params={}, mode='folder',iconImage='DefaultFolder.png', infoLabels=None, fanart=FANART,contextmenu=None):
    url = build_url({'mode': mode, 'foldername': name, 'ex_link' : ex_link, 'params' : params})

    li = xbmcgui.ListItem(name)
    if infoLabels:
        li.setInfo(type="video", infoLabels=infoLabels)
    
    art_keys=['thumb','poster','banner','fanart','clearart','clearlogo','landscape','icon']
    art = dict(zip(art_keys,[iconImage for x in art_keys]))
    art['landscape'] = fanart if fanart else art['landscape'] 
    art['fanart'] = fanart if fanart else art['landscape'] 
    li.setArt(art)
    if contextmenu:
        contextMenuItems=contextmenu
        li.addContextMenuItems(contextMenuItems, replaceItems=True) 
    else:
        contextMenuItems = []
        contextMenuItems.append(('Informacja', 'XBMC.Action(Info)'),)
        li.addContextMenuItems(contextMenuItems, replaceItems=False)  
          
    xbmcplugin.addDirectoryItem(handle=addon_handle, url=url,listitem=li, isFolder=True)
    xbmcplugin.addSortMethod(addon_handle, sortMethod=xbmcplugin.SORT_METHOD_NONE, label2Mask = "%R, %Y, %P")

def encoded_dict(in_dict):
    out_dict = {}
    for k, v in in_dict.iteritems():
        if isinstance(v, unicode):
            v = v.encode('utf8')
        elif isinstance(v, str):
            # Must be encoded in UTF-8
            v.decode('utf8')
        out_dict[k] = v
    return out_dict
    
def build_url(query):
    return base_url + '?' + urllib.urlencode(encoded_dict(query))

## ######################

def ListMovies(params):
    filmy,pagination = filmyto.scanMainpage(**params)
    if pagination[0]:
        addLinkItem(name='[COLOR blue]<< Poprzednia strona <<[/COLOR]', url='', params=pagination[0], mode='page:ListItems', IsPlayable=False)
    items=len(filmy)
    for f in filmy:
        isFolder,t0=(True,'') if f.get('url','').startswith('/serial') else (False,'')
        addLinkItem(name=t0+f.get('title'), url=f.get('url',''), mode='getContent', iconimage=f.get('img'), infoLabels=f, isFolder=isFolder, IsPlayable=True,itemcount=items)
    if pagination[1]:
        addLinkItem(name='[COLOR blue]>> Następna strona >>[/COLOR]', url='', params=pagination[1], mode='page:ListItems', IsPlayable=False)
    xbmcplugin.setContent(addon_handle, 'movies')

def getSeasons(ex_link):
    seasons = filmyto.getSeasons(ex_link)
    items=len(seasons)
    for f in seasons:
        addLinkItem(name=f.get('title'), url=f.get('url',''), mode='getEpisodes', iconimage=f.get('img'), infoLabels=f, isFolder=True, IsPlayable=True,itemcount=items)
    xbmcplugin.setContent(addon_handle, 'tvshows')
    
def getEpsodes(ex_link):
    episodes = filmyto.getEpsodes(ex_link)
    items=len(episodes)
    for f in episodes:
        addLinkItem(name=f.get('title'), url=f.get('url',''), mode='getLinks', iconimage=f.get('img'), infoLabels=f, isFolder=False, IsPlayable=True,itemcount=items)
    xbmcplugin.setContent(addon_handle, 'episodes')
    
def getLinks(ex_link):
    links = filmyto.getLinks(ex_link)
    print links
    stream_url=''
    t = [ x.get('title') for x in links]
    u = [ x.get('url') for x in links]
    selection = xbmcgui.Dialog().select("Sources", t)
    if selection>-1:
        link = links[selection].get('url')
        
        try:
            stream_url = urlresolver.resolve(link)
        except Exception,e:
            stream_url=''
            xbmcgui.Dialog().ok('[COLOR red]Problem[/COLOR]','Może inny link będzie działał?','ERROR: %s'%str(e))
    
    print stream_url
    if stream_url:
        xbmcplugin.setResolvedUrl(addon_handle, True, xbmcgui.ListItem(path=stream_url))
    else:
        xbmcplugin.setResolvedUrl(addon_handle, False, xbmcgui.ListItem(path=''))
## ######################
## MAIN
## ######################
            
    
# Get passed arguments
mode = args.get('mode', None)
fname = args.get('foldername',[''])[0]
ex_link = args.get('ex_link',[''])[0]
params = args.get('params',[{}])[0]

sortV = my_addon.getSetting('sortV')
sortN = my_addon.getSetting('sortN') if sortV else 'Według daty dodania'
orderV = my_addon.getSetting('orderV')
orderN = my_addon.getSetting('orderN') if orderV else 'Malejąco'
gatunekV = my_addon.getSetting('gatunekV')
gatunekN = my_addon.getSetting('gatunekN') if gatunekV else 'Wszystkie'
produkcjaV = my_addon.getSetting('produkcjaV')
produkcjaN = my_addon.getSetting('produkcjaN') if produkcjaV else 'Wszystkie'


if mode is None:
    addLinkItem("[COLOR blue]Sortowanie:[/COLOR] [B]"+sortN+"[/B]",'',mode='filtr:sort',iconimage='',IsPlayable=False)
    addLinkItem("[COLOR blue]Kolejność:[/COLOR] [B]"+orderN+"[/B]",'',mode='filtr:order',iconimage='',IsPlayable=False)
    addLinkItem("[COLOR blue]Gatunek:[/COLOR] [B]"+gatunekN+"[/B]",'',mode='filtr:gatunek',iconimage='',IsPlayable=False)
    addLinkItem("[COLOR blue]Produkcja:[/COLOR] [B]"+produkcjaN+"[/B]",'',mode='filtr:produkcja',iconimage='',IsPlayable=False)
    addDir(name="Filmy",ex_link='',params={'type':'filmy','page':'1','options':''}, mode='ListItems',iconImage='')
    addDir(name="Seriale",ex_link='',params={'type':'seriale','page':'1','options':''}, mode='ListItems',iconImage='')
    addDir(name="Dla dzieci",ex_link='',params={'type':'dzieci','page':'1','options':''}, mode='ListItems',iconImage='')
    addDir(name="Dokumentalne",ex_link='',params={'type':'dokumentalne','page':'1','options':''}, mode='ListItems',iconImage='')
    addDir('[COLOR green]Szukaj[/COLOR]','',mode='SzukajNowe')
    
elif 'filtr' in mode[0]:
    _type = mode[0].split(":")[-1]
    if _type=='sort':
        label=['Według daty dodania','Według tytułu','Według roku produkcji','Według oceny']
        value=['','sortowanie=tytul','sortowanie=rok','sortowanie=ocena']
        msg = 'Sortowanie'
    elif _type=='order':
        label=['Malejąco','Rosnąco']
        value=['','kolejnosc=rosnaco']
        msg = 'Kolejność'
    elif _type=='gatunek' or _type=='produkcja':
        value,label = filmyto.getGP(_type)
        msg = _type.title()
    s = xbmcgui.Dialog().select(msg,label)
    s = s if s>-1 else 0
    my_addon.setSetting(_type+'V',value[s])
    my_addon.setSetting(_type+'N',label[s])
    xbmc.executebuiltin('XBMC.Container.Refresh')

elif mode[0] =='SzukajNowe':
    d = xbmcgui.Dialog().input('Szukaj, Podaj tytuł filmu/serialu/bajki', type=xbmcgui.INPUT_ALPHANUM)
    if d:
        filmy = filmyto.search(d)
        items=len(filmy)
        for f in filmy:
            isFolder,t0=(True,'(S) ') if f.get('url','').startswith('/serial') else (False,'(F) ')
            addLinkItem(name=t0+f.get('title'), url=f.get('url',''), mode='getContent', iconimage=f.get('img'), infoLabels=f, isFolder=isFolder, IsPlayable=True,itemcount=items) 
        xbmcplugin.setContent(addon_handle, 'movies')
    
elif mode[0].startswith('page'):
    tmp,nmode = mode[0].split(':')
    url = build_url({'mode': nmode, 'foldername': '', 'ex_link' : ex_link, 'params':params})
    xbmc.executebuiltin('XBMC.Container.Refresh(%s)'% url)
    
elif mode[0] == 'ListItems':
    params=eval(params)
    for x in [sortV,orderV,gatunekV,produkcjaV]: params['options']+='&%s'%x if x else ''
    ListMovies(params)
    
elif mode[0] == 'getEpisodes': 
    getEpsodes(ex_link)

elif mode[0] == 'getContent':
    if ex_link.startswith('/film'):
        getLinks(ex_link)
    else:
        getSeasons(ex_link)
        
elif mode[0] =='getLinks':
    getLinks(ex_link)       
   

else:
    xbmcplugin.setResolvedUrl(addon_handle, False, xbmcgui.ListItem(path=''))        


xbmcplugin.endOfDirectory(addon_handle)

